/* See {cryptoy.h} */
/* Last edited on 2013-09-03 13:44:48 by stolfi */

#define cryptoy_C_copyright \
  "Copyright © 2013 Jorge Stolfi, State University of Campinas"

#include <stdio.h>
#include <errno.h>
#include <stdint.h>
#include <assert.h>
#include <stdlib.h>

#include <cryptoy.h>

int cryptoy_xor_files(FILE *a, FILE *b, FILE *c)
  { int N = 1024; /* Buffer size */
    unsigned char abuf[N]; /* Buffer for input file {a} and output file {c}. */
    uint64_t nw = 0;       /* Total bytes written to file {c}. */
    unsigned char bbuf[N]; /* Buffer for input file {b}. */

    while(1)
      { /* Read a buffer-load from each file: */
        size_t ma = fread(abuf, 1, N, a);
        if ((ma < N) && (! feof(a))) { fprintf(stderr, "i/o error reading file 1\n"); return -1; }
        size_t mb = fread(bbuf, 1, N, b);
        if ((mb < N) && (! feof(b))) { fprintf(stderr, "i/o error reading file 2\n"); return -1; }
        if (ma > mb) { fprintf(stderr, "file 1 is longer than file 2\n"); return -1; }
        /* Combine buffers: */
        int mc = ma;
        int k;
        for (k = 0; k < mc; k++) { abuf[k] ^= bbuf[k]; }
        size_t mw = fwrite(abuf, 1, mc, c);
        nw += mw;
        if (mw < mc) { fprintf(stderr, "i/o error writing the output file\n"); return -1; } 
        if (mc < N) { break; }
      }
    fflush(c);
    return nw;
  }

#define cryptoy_C_rights \
  cryptoy_C_copyright ".\n" \
  "This file is provided 'as is'; the author and his employer are" \
  " not liable for any damages that may result from its use.  This" \
  " file can be used and modified for any purpose as long as" \
  " the copyright and this 'rights' note are preserved in" \
  " all copies and derived versions.";
